/*
 * Copyright [yyyy] [name of copyright owner]
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


// Anonymous function start
//
(function( window, undefined )
{

// reference
var Config			= window.h5glib.Config;
var Debug			= window.h5glib.Debug;
var Command			= window.h5glib.Command;
var Task			= window.h5glib.Task;
var SoundTask		= window.h5glib.SoundTask;
var Scene			= window.h5glib.Scene;

/**
 * StringRes
 */
var StringRes =
{
};


/**
 * ColorRes
 */
var ColorRes =
{
	PANEL			: "gainsboro",
	FONT_MAIN		: "white"
};

/**
 * FontRes
 */
var FontRes =
{
	LARGE		: "bold 18px 'ＭＳ Ｐゴシック'",
	SMALL		: "bold 14px 'ＭＳ Ｐゴシック'"
};

/**
 * MenuTask
 */
var MenuTask = function( scene )
{
	this.command	= scene.command;	// input
};
MenuTask.prototype = new Task();

(function( pt )
{
	/**
	 * 描画する。
	 */
	pt.draw = function( scene )
	{
		var canvas		= scene.canvas;
		var context		= scene.context;

		context.save();

		context.fillStyle = ColorRes.PANEL;
		context.fillRect( 0, 0, canvas.width, canvas.height );

		context.font		= FontRes.LARGE;
		context.fillStyle	= ColorRes.FONT_MAIN;
		context.fillText( "Menu", 100, 100 );

		context.restore();
	};
})( MenuTask.prototype );

/**
 * InputCommand
 */
var InputCommand = function()
{
	this.tbl.escape	= 0;
};
InputCommand.prototype = new Command();

(function( pt )
{
	/**
	 * 
	 */
	pt.handleSysEvent = function( event )
	{
		var type = event.type.toLowerCase();
		if ( type.substring( 0, 3 ) == "key" )
		{
			var value = 0;
			if      ( type == "keydown" ) { value = 1; }
			else if ( type == "keyup"   ) { value = 0; }

			switch ( event.keyCode )
			{
				case 27:	this.tbl.escape	= value; break;	// ESC
			}
		}
	};
})( InputCommand.prototype );

/**
 * MenuScene
 */
var MenuScene = function( app, name )
{
	this.app		= app;
	this.name		= name;
	this.stageName	= null;

	this.command	= new InputCommand();

	this.menuTask	= new MenuTask( this );
	this.child		= this.menuTask;	// head of task list

	// message handler
	//this.msgManager	= new MessageManager();
};
MenuScene.prototype = new Scene();

(function( pt )
{
	/**
	 * 
	 */
	pt.show = function()
	{
		this.command.clear();

		this.holdCanvas();
		this.drawChildren( this );
	};
	/**
	 * 
	 */
	pt.update = function()
	{
		this.ticks++;

		// change scene
		if ( this.command.tbl.escape )
		{
			var nextScene = this.app.sceneManager.push( this.stageName );
			nextScene.show();
			return;
		}

		// update & draw
		if ( this.updateChildren( this ) )
		{
			this.drawChildren( this );
		}
	};
})( MenuScene.prototype );


// Expose
if ( !window.h5glib ) { window.h5glib = {}; }
window.h5glib.MenuScene		= MenuScene;


// Anonymous function end
//
})( window );
